# Castorcito
Castorcito allows you to create custom components according to the different needs that your web project may require.
That is why castorcito contains a set of pre-designed components such as Banners, Tabs, Accordions, Quotes, Cards, among others.
To obtain this package of components you must activate the module castorcito_packbase. For a better understanding of the creation of components, you can review the components generated by castorcito_basepack.
If you plan to use one of these components, we recommend you to clone the component and use the clone, this way you will have more control and always keep a backup of the original.

**Note:** This module is currently incompatible with the Klaro Cookie & Consent Manager contrib module. Klaro Cookie & Consent Manager is installed by default in Drupal CMS.

## Managing templates

This module create a formatter to be used in a JSON field.
- First, in managed form display we have to select the option "Castorcito Component" and configurate the component that will be able to this field.
- After that, in managed display we have to select the formatter "Castorcito component" and save that.

This options have to be configurated to templates are able in the site.

The template is defined trought the formatter created by this module. The template is located in the following module's directory:

```
/templates/field--castorcito-component-formatter.html.twig
```

Inside this template there's validations and loops to managed how to render every castorcito field. Every field has a basic html markup inside its related sdc:

```
/components/fields/castorcito_field_name/castorcito_field_name.twig
```

In the twig code, the "component_data" variable has all the information about every component used in this field.

## How to overwrite this markup?
The markup of every cfield is related to a SDCi. You only can overwrite SDC using your themes.
You have to copy the SDC files from the origin module and paste into the root of the theme, after that you only have to add a key and value (replaces) in the .component.yml file
```
replaces: 'castorcito:name-sdc'
```
For example if you want to overwrite the markup from castorcito_plain_text SDC you have to copy the directory with the fields from the core of castorcito and paste in mycustom_theme/components/castorcito_plain_text/  and inside its .component.yml add the line replaces: 'castorcito:castorcito_plain_text'

After added this values you can make all the changes you want from the theme.

# Castorcito_basepack
This castorcito submodule add many default components to be used in multiple scenaries, every one has its own cfields, its configuration and its components files (SDC).
Every component has a default look and feel to be adapted in any current theme, some of them components also include js code to get the properly behaviour.
Be free to test them!


## How to overwrite this components markup?
It's the same way to overwrite cfields, you only have to copy the SDC related to a castorcito_basepack component from the module to the theme and then define the replaces key and value

For example:
Copy the SDC from castorcito/modules/castorcito_basepack/components/basepack_quote/ to custom_theme/components/basepack_quote/ and then you only have to add a key and value (replaces) in the .component.yml file
```
replaces: 'castorcito_basepack:basepack_quote'
```

After added this values you can make all the changes you want from the theme.


# Process of upgrading from 1.0.0-alpha1 to latest

- Install config_delete module
- Delete config REST resource block_list_resource
- Upgrade to latest version with composer or git if use dev version
- Go to /update.php

# Installing JSON Editor with composer

One of the dependencies of this module is [json_field], this module adds a solution for adding jsoneditor to a site using Composer.
This solution can be found in the [README.md] of the [json_field] module in the "Installing JSON Editor with composer" section.
